config/routes.rb
Rails.application.routes.draw do
  root to: 'pages#home'
  get 'ourwork' => 'pages#ourwork', as: :ourwork
  devise_for :users
  
  resources :gfs_registrations do
    collection do
      get :gfs_terms
    end
  end
  namespace :user do
    resources :messages do
      collection do
        get :get_messages
      end
    end
    resources :tests 
    resource :dashboard, controller: :dashboard
    resources :assignments do
      member do
        post :start
        get :started
        post :next
        get :complete
        get :completed
        get :show_reviewed_test
      end
      collection do
        get :reviewed
      end
    end
  end

  namespace :staff do
    resources :messages do
      collection do
        get :get_messages
        get :get_users
      end
    end
    resources :guest_users
    resource :dashboard, controller: :dashboard do 
      collection do
        get :pending_reviews
        get :completed_reviews
      end
    end
    resources :users do
      resources :assignments do
        member do
          get :review
          put :review_feedback
        end
      end
    end
    resources :questions do
      collection do
        get :upload_file
        post :upload
      end
    end
    resources :tests do
      member do
        get :upload_file
        post :upload
        get :print
      end
      resources :sections do
        member do
          get :questions
          put :questions_update
        end
      end
    end
  end

  namespace :guest_user do
    resources :tests, only: [:show] do
      member do
        get :new_register
        post :register
        post :start
        get :started
        post :next
        get :complete
        get :completed

      end
    end
  end
  
  resources :events do
    member do
      get :register
      get :registered_users
      get :details
      get :print_qr
      get :print_reg_users
    end
    collection do
      get ':category/listing' => 'events#listing', as: :listing
    end

    resources :feedbacks, :controller => "student_feedbacks"
    resources :registrations, :controller => "event_registrations"
  end


  get '/online/:slug' => 'user/tests#register', as: :online_test
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/question.rb
class Question < ApplicationRecord
  #CATEGORIES = ['science', 'maths', 'reasoning', 'interests']
  enum q_type: { single_answer: 0, multiple_answer: 1, theory: 2 }
  before_save :downcase_category

  has_many :answers, dependent: :destroy
  has_many :section_questions


  validates :text, presence: true
 
  def downcase_category
    self.category = self.category.downcase if self.category.present?
  end
end

app/controllers/staff/assignments_controller.rb
class Staff::AssignmentsController < ApplicationController
  
  def new
    @assignment = Assignment.new
  end

  def create
    @assignment = Assignment.new(assignment_params)
    @assignment.user_id = params[:user_id]
    if @assignment.save
      redirect_to staff_user_path(params[:user_id])
    else
      render action: :new
    end
  end

  def destroy
    @assignment = Assignment.find(params[:id])
    @assignment.archived = true
    @assignment.save
    redirect_to staff_user_path(params[:user_id])
  end
  
  def review
    @assignment = Assignment.find(params[:id])
    @test = Test.find(@assignment.test_id)
    @sections = Section.where(test_id: @test.id, archived: false)
    @result = Result.find_by(assignment_id: @assignment.id) || Result.new(answers: {})
  end

  def review_feedback
    @assignment = Assignment.find(params[:id])
    @assignment.status = "reviewed"
    @assignment.feedback = params[:assignment][:feedback]
    @assignment.save
    redirect_to staff_dashboard_path
  end

  private
  def assignment_params
    params.require(:assignment).permit(:due_date, :test_id)
  end

end

app/controllers/staff/dashboard_controller.rb
class Staff::DashboardController < ApplicationController

  def show
    @assignments = Assignment.where(status: 'completed')
    @completed_assignments = Assignment.where(status: 'reviewed')
  end

  def pending_reviews
    @assignments = Assignment.where(status: 'completed').order(created_at: :desc)
  end

  def completed_reviews
    @assignments = Assignment.where(status: 'reviewed').order(created_at: :desc)
  end
  
end

app/controllers/staff/guest_users_controller.rb
class Staff::GuestUsersController < ApplicationController
  
  def index
    @guest_users = GuestUser.all
  end

  def show
    @guest_user = GuestUser.find(params[:id])
  end

  def destroy
    @guest_user = GuestUser.find(params[:id])
    @guest_user.destroy()
    redirect_to staff_guest_users_path
  end
end

app/controllers/staff/messages_controller.rb
class Staff::MessagesController < ApplicationController

  def create
    @user = User.find(params[:user_id])
    @message = Message.new(message_params)
    @message.discussion_id = @user.id
    @message.sender_id = current_user.id
    @message.save

    respond_to do |format|
      format.html {
        redirect_to staff_get_messages_path(user_id: @user.id)
      }
      format.js {get_messages}
    end
  end
  
  def index
    get_users
    if params[:user_id].present?
      @user = User.find(params[:user_id])
      @messages = Message.where(:discussion_id => @user.id).order(:created_at)
    end
  end

  def get_messages
    @user = User.find(params[:user_id])
    @messages = Message.where(:discussion_id => @user.id).order(:created_at)
    @messages.where(sender_id: @user.id).update_all(is_read: true)
    get_users
  end

  def get_users
    @users = User.all
  end

  private
  def message_params
    params.require(:message).permit(:text)
  end

end

app/controllers/staff/questions_controller.rb
class Staff::QuestionsController < ApplicationController

  def new
     @question = Question.new
  end

  def create
    @question = Question.new(question_params)
    if @question.save
      answers_params.each do |i, ap|
        @answer = Answer.new(ap)
        if @answer.description.present?
          @answer.question_id = @question.id
          @answer.save
        end
      end

      redirect_to staff_questions_path
    else
      render action: :new
    end
  end
  
  def index
    @page = params[:page].to_i
    @per_page = 10
    @questions = Question.where(archived: false).order(created_at: :desc).limit(@per_page).offset(@page * @per_page)
    @next = true if (Question.where(archived: false).count/@per_page.to_f)-1 > @page
  end

   def destroy
    @question = Question.find(params[:id])
    @question.archived = true
    @question.save
    redirect_to staff_questions_path
  end

  def upload_file
  end

  def upload
    if params[:csv].present?
      CSV.parse(params[:csv].read, headers: true).each do |row|
        question = Question.create!(
          text: row['question'],
          q_type: row['question_type'],
          category: row['category'],
        )

        %w(ans1 ans2 ans3 ans4).each do |ans_key|
          question.answers.create!(description: row[ans_key], is_correct: row['correct_answer'] == ans_key) if row[ans_key].present?
        end
      end

      redirect_to staff_questions_path
    else
      flash[:notice] = "Please upload the file"
      render action: :upload_file
    end
  end

  private
    def question_params
      params.require(:question).permit(:q_type, :category, :text)
    end

    def answers_params
      params.permit(answers: [:description, :is_correct])[:answers]
    end
end

app/controllers/staff/sections_controller.rb
class Staff::SectionsController < ApplicationController
  
  def new
    @section = Section.new
  end

  def create 
    @questions = Question.all
    @section = Section.new(section_params)
    @section.test_id = params[:test_id]
    if @section.save
      redirect_to staff_test_path(params[:test_id])
    else
      render action: :new
    end
  end

  def questions
    @section = Section.find params[:id]
    @questions = Question.where archived: false, category: @section.category

    @section_questions = SectionQuestion.where(section_id: @section.id)
    @selected_questions = Question.where(id: @section_questions.collect(&:question_id))
    @other_questions = Question.where(category: @section.category, archived: false).where.not(id: @section_questions.collect(&:question_id))
    @question = Question.last
  end

  def questions_update
    @section = Section.find params[:id]

    # Insert each question id if already not present
    params[:question_ids].each do |question_id|
      unless SectionQuestion.find_by_section_id_and_question_id(@section.id, question_id).present?
        SectionQuestion.create(section_id: @section.id, question_id: question_id)
      end
    end

    # remoe question ids other than selected
    SectionQuestion.where(section_id: @section.id).where.not(question_id: params[:question_ids]).destroy_all

    redirect_to staff_test_path(params[:test_id])
  end

  def destroy
    @section  = Section.find(params[:id])
    @section.archived = true
    @section.save
    redirect_to staff_test_path(params[:test_id])
  end

  private
    def section_params
      params.require(:section).permit(:name, :category, :guidelines)
    end
  
end

app/controllers/staff/tests_controller.rb
class Staff::TestsController < ApplicationController
  
  def new
    @test = Test.new
  end

  def create
    @test = Test.new(test_params)
    if @test.save
      redirect_to staff_test_path(@test)
    else
      render action: :new
    end
  end

  def index
     @tests = Test.where(archived: false).order(created_at: :desc)
  end

  def show
    @sections = Section.where(test_id: params[:id], archived: false)
    @test = Test.find(params[:id])
  end

  def destroy
    @test = Test.find(params[:id])
    @test.archived = true
    @test.save
    redirect_to staff_tests_path
  end

  def print
    @test = Test.find(params[:id])
    @sections = Section.where(test_id: params[:id], archived: false)
    render layout: 'print'
  end

  def upload_file
  end

  def upload
    @test = Test.find(params[:id])
    current_section = nil
    CSV.parse(params[:csv].read).each do |row|
      next if row.compact.count == 0

      if row.compact.count <= 2
        current_section = Section.create!(
          name: row[0],
          guidelines: row[1],
          test_id: @test.id,
          category: '_' + Time.now.to_i.to_s + '_' + rand(1000).to_s
        )
      end

      if row.compact.count > 2
        question = Question.create!(
          q_type: row[0],
          text: row[1],
          category: current_section.category
        )

        correct_answer_indexes = row[2].split(',').map &:strip
        [3, 4, 5, 6].each_with_index do |key, index|
          question.answers.create!(description: row[key], is_correct: correct_answer_indexes.include?((index+1).to_s)) if row[key].present?
        end

        SectionQuestion.create(section_id: current_section.id, question_id: question.id)
      end
    end
    redirect_to staff_test_path(@test.id)
  end

  private
    def test_params
      params.require(:test).permit(:name, :duration, :guidelines)
    end

end

app/controllers/staff/users_controller.rb
class Staff::UsersController < ApplicationController

  def new
    @user = User.new
  end

  def create
    @user = User.new(user_params)
    @user.role = "staff"
    if @user.save 
      redirect_to staff_users_path
      else
      render action: :new
    end
  end

  def index
    @users = User.where(archived: false).order(created_at: :desc)
    @users = @users.paginate(:page => params[:page], :per_page => 20)
  end

  def update
    @user = User.find(params[:id])
    if @user.update_attributes(user_params)
        flash[:success]="Successfully updated"
        redirect_to staff_user_path()
      else
        render 'edit'
    end
  end 

  def edit
    @user = User.find(params[:id])
  end

  def show
    @user = User.find(params[:id])
    @assignments = Assignment.where(:user_id => params[:id], archived: false, status: nil)
  end

  def destroy
    @user = User.find(params[:id])
    @user.archived = true
    @user.email = "deleted-#{Time.now.to_i}-#{@user.email}"
    @user.save
    redirect_to staff_users_path
  end

  private
    def user_params
      params.require(:user).permit(:name, :phone_no, :address, :password, :password_confirmation, :email, :role).tap do |p|
        if p[:password].empty? and p[:password_confirmation].empty?
          p.delete :password
          p.delete :password_confirmation
        end
      end
    end

end

app/helpers/staff/assignments_helper.rb
module Staff::AssignmentsHelper
end

app/helpers/staff/dashboard_helper.rb
module Staff::DashboardHelper
end

app/helpers/staff/guest_user_helper.rb
module Staff::GuestUserHelper
end

app/helpers/staff/messages_helper.rb
module Staff::MessagesHelper
end

app/helpers/staff/questions_helper.rb
module Staff::QuestionsHelper
end

app/helpers/staff/sections_helper.rb
module Staff::SectionsHelper
end

app/helpers/staff/student_feedbacks_helper.rb
module Staff::StudentFeedbacksHelper
end

app/helpers/staff/tests_helper.rb
module Staff::TestsHelper
end

app/helpers/staff/users_helper.rb
module Staff::UsersHelper
end

app/views/staff/questions/index.html.erb
<div>
  <%= link_to "Add Question", new_staff_question_path, class: "btn", style: "float: right;" %> 
  <%= link_to "upload Questions", upload_file_staff_questions_path, class: "btn", style: "float: right; margin-right: 10px;" %>
  <h4>Questions List</h4>
</div>
<%= Question.where(archived: false).count %> Questions
<br/>
<br/>
<% if @questions.present? %>
  <table class="striped">
    <tr>
      <th>Questions</th>
      <th>Category</th>
      <th></th>
    </tr>
    <tbody>
      <% @questions.each do |question| %>
        <tr>
          <td><%= question.text %></td>
          <td><%= question.category unless question.category.to_s.match(/^_/) %></td>
          <td><%= link_to staff_question_path(question), method: :delete, data: { confirm: "You sure?"  } do %>
                                    Delete<% end %></td>
        </tr>
      <% end %>
    </tbody>
  </table>

  <div style="margin-top: 10px;">
    <div style="float: left;">
      <% if @page != 0 %>
        <%= link_to "< Prev", staff_questions_path(page: @page-1) %>
      <% end %>

      <% if @next %>
        <%= link_to "Next >", staff_questions_path(page: @page+1) %>
      <% end %>
    </div>

    <div style="float: right;">
      <%= @page+1 %>/<%= (Question.where(archived: false).count/@per_page.to_f).ceil %> Pages
    </div>

    <div class="clear-height"></div>
  </div>
  <% else %>
    <div style="text-align: center; background-color: #eee; padding-top: 15px;">
      Sorry you don't have any Questions
      <br />
      <br />
    </div>
<% end %>

app/views/staff/questions/new.html.erb
<h4>Add New Question & Answer</h4>
<%= form_for :question, url: staff_questions_path do |f| %>
  <%= f.error_messages %>
  <div style="height: auto;">
    <div style="float: left;">
      <div class="group">
        <%= f.label :"Question_type "%>
        <%= f.select(:q_type, Question.q_types.keys, {:prompt => 'select'}) %>
      </div>
    </div>

    <div style="float: left; padding-left: 200px;">
      <div class="group">
        <%= f.label :"category "%>
        <%= f.text_field :category %>
      </div>
    </div>
    <div class="clear-height"></div>
  </div>

  <div class="group">
    <%= f.label :"Add Question "%>
    <%= f.text_area :"text" %>
  </div>

  <div class="group">
    <%= f.label :"Answers" %>
    <table>
      <%= fields_for 'answers[0]', Answer.new do |ans| %>
        <tr>
          <td width='5'>1.</td>
          <td><%= ans.text_field :description %></td>
          <td width='5'><%= ans.check_box :is_correct %></td>
        </tr>
      <% end %>

      <%= fields_for 'answers[1]', Answer.new do |ans| %>
        <tr>
          <td>2.</td>
          <td><%= ans.text_field :description %></td>
          <td><%= ans.check_box :is_correct %></td>
        </tr>
      <% end %>

      <%= fields_for 'answers[2]', Answer.new do |ans| %>
        <tr>
          <td>3.</td>
            <td><%= ans.text_field :description %></td>
            <td><%= ans.check_box :is_correct %></td>
        </tr>
      <% end %>

      <%= fields_for 'answers[3]', Answer.new do |ans| %>
        <tr>
          <td>4.</td>
          <td><%= ans.text_field :description %></td>
          <td><%= ans.check_box :is_correct %></td>
        </tr>
      <% end %>
    </table>
  </div>

  <div class="group" style="text-align: center;">
    <%= f.submit "Submit", class: "btn"%>
    <%= link_to 'Cancel', staff_questions_path, class: "btn"%>
  </div>
<% end %>

app/views/staff/questions/upload_file.html.erb
<%= form_for :questions, url: upload_staff_questions_path, html: {multipart: true}  do |f| %>
<%= file_field_tag :"csv" %>
<%= f.submit "Submit", class: "btn" %>
<% end %>